%Loads data from an ADAMS output file
%Sean Bailey
%Biomimetics
%01/16/2002

%TODO List 02/05/02 (TM)
%DONE-Add menu for file selection
%DONE-Loop file input for multiple files
%DONE-Rename Data to data00x for multiple files   

%counts number of variables
%deals with blocking of 5 variables at a time
%Puts all the data into a large data array

%clean up the workspace
%clear all
%close all
%clc

%Constants
TRUE = 1;
FALSE = 0;
%Variables
pselect=0;
fcount=1;
while pselect~=2
%Data file name
[fname fpath]=uigetfile('*.*','Select data file');
 
%First open and parse through the entire file, counting the number of variables
fid = fopen( fname, 'r' );
disp(' ')
disp(' ')
%disp( strcat('Parsing data file: ', fname ) )
LineCounter = 0;
VariableCounter = 0;
FileLine = 1;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
while( FileLine(1) ~= -1 )  %go until end of file
   FileLine = fgets( fid );
   FileLineSize = size( FileLine );
   if( FileLineSize(2) >= 3 )  %make sure fileline is big enough
      if( ((FileLine(2)+0) == 46) & ((FileLine(3)+0) == 32) )  %". " indicates variable description
         VariableCounter = VariableCounter+1;
      end
   end
   LineCounter = LineCounter + 1;
end
%Display the number of variables found
%disp( strcat( 'Number of lines processed: ', num2str( LineCounter ) ) )
%disp( strcat( 'Number of variables found: ', num2str( VariableCounter ) ) )
%Close the file
fclose( fid );

%Now, go through the file, reading in the data
fid = fopen( fname, 'r' );
disp(' ')
disp( strcat('Reading data from file: ', fname ) )
NumberOfVariables = VariableCounter;
FileLine = 1;  %file line string
LineCounter = 0;  %file line number
ReadingDataBlockFlag = FALSE;  %flag for switching in and out of data blocks
DataBlockCounter = 0;  %Data block counter
DataBlockLineCounter = 0;  %Data line counter within the data block
while( FileLine(1) ~= -1 )  %go until end of file
   FileLine = fgets( fid );
   LineCounter = LineCounter+1;
   FileLineSize = size( FileLine );
   if( FileLineSize(2) < 3 )  %make sure fileline is big enough
      ReadingDataBlockFlag = FALSE;  %Too short to be a data line
   else
       %if the first space is blank, and the second one is not, then it is a data line
       %also a data line if the first space is a negative sign
      if( ~( ...  %not
              ((FileLine(1)+0) == 45) ...  %first character is a negative
              | ...  %or
              ( ((FileLine(1)+0) == 32) & ((FileLine(2)+0) ~= 32) )  ...  %space and then something not a space
              ) )  %then it is not a dataline
         ReadingDataBlockFlag = FALSE;
      else  %(is dataline)
         if( ReadingDataBlockFlag == FALSE )  %a new data block
            DataBlockCounter = DataBlockCounter + 1;
            DataBlockNumberOfVariables = min( 5, (NumberOfVariables-(DataBlockCounter-1)*5) );
            DataBlockLineCounter = 0;
            ReadingDataBlockFlag = TRUE;
         end
         DataBlockLineCounter = DataBlockLineCounter+1;
         switch( DataBlockNumberOfVariables )
         case 1,
            Data(DataBlockLineCounter, (DataBlockCounter-1)*5+1) = ...
               sscanf( FileLine, '%f')';
         case 2,
            Data(DataBlockLineCounter, (DataBlockCounter-1)*5+1:(DataBlockCounter-1)*5+2) = ...
               sscanf( FileLine, '%f %f')';
         case 3,
            Data(DataBlockLineCounter, (DataBlockCounter-1)*5+1:(DataBlockCounter-1)*5+3) = ...
               sscanf( FileLine, '%f %f %f')';
         case 4,
            Data(DataBlockLineCounter, (DataBlockCounter-1)*5+1:(DataBlockCounter-1)*5+4) = ...
               sscanf( FileLine, '%f %f %f %f')';
         case 5,
            Data(DataBlockLineCounter, (DataBlockCounter-1)*5+1:(DataBlockCounter-1)*5+5) = ...
               sscanf( FileLine, '%f %f %f %f %f')';
         end  %case
      end  %if( ' .' )
   end  %if( file line size)
   if( 0 )  %debug
       disp( strcat( 'FileLine ', FileLine ) )
       disp( strcat( 'LineCounter ', num2str( LineCounter ) ) )
       disp( strcat( 'ReadingDataBlockFlag ', num2str( ReadingDataBlockFlag ) ) )
       disp( strcat( 'DataBlockCounter ', num2str( DataBlockCounter ) ) )
       disp( strcat( 'DataBlockLineCounter ', num2str( DataBlockLineCounter ) ) )
       disp( ' ' )
       pause
   end  %debug
end  %while !EOF


%display stuff
%disp( strcat( 'Number of lines processed: ', num2str( LineCounter ) ) )
%disp( strcat( 'Number of lines of data processed: ', num2str( DataBlockLineCounter ) ) )
%disp( strcat( '''', fname, ''' was loaded into the array ''data00', num2str(fcount), ''''  ) )
fprintf(['''' fname ''' was loaded into the array ''data00' num2str(fcount) '''\n']);
%Close the file
fclose( fid );

eval(['data00' num2str(fcount) '=Data;']);
fcount=fcount+1;
pselect=menu('Select a file for processing?','Yes','No');
clear Data
end

clear DataBlockCounter DataBlockLineCounter DataBlockNumberOfVariables ...
	fname FALSE FileLine FileLineSize LineCounter NumberOfVariables ...
   ReadingDataBlockFlag TRUE VariableCounter ans fid pselect fcount Data fpath
   
